import { EventEmitter } from '../../stencil-public-runtime';
import { IconPack } from '../../lib/icons';
import { Meeting } from '../../types/dyte-client';
import { Size, States } from '../../types/props';
import { ControlBarVariant } from '../dyte-controlbar-button/dyte-controlbar-button';
/**
 * A button which toggles visibility of polls.
 *
 * You need to pass the `meeting` object to it to see the unread polls count badge.
 *
 * When clicked it emits a `dyteStateUpdate` event with the data:
 *
 * ```ts
 * { activeSidebar: boolean; sidebar: 'polls' | 'none' }
 * ```
 */
export declare class DytePollsToggle {
  /** Variant */
  variant: ControlBarVariant;
  /** Meeting object */
  meeting: Meeting;
  /** States object */
  states: States;
  /** Size */
  size: Size;
  /** Icon pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  pollsActive: boolean;
  unreadPollsCount: number;
  private onPollsUpdate;
  connectedCallback(): void;
  meetingChanged(meeting: Meeting): void;
  statesChanged(s?: States): void;
  /** Emits updated state data */
  stateUpdate: EventEmitter<States>;
  private togglePollsTab;
  render(): any;
}
