import { IconPack } from '../../lib/icons';
import { Meeting, MediaPermission } from '../../types/dyte-client';
import { Size } from '../../types/props';
import { ControlBarVariant } from '../dyte-controlbar-button/dyte-controlbar-button';
/**
 * A button which toggles your screenshare.
 */
export declare class DyteScreenShareToggle {
  /** Variant */
  variant: ControlBarVariant;
  /** Meeting object */
  meeting: Meeting;
  /** Size */
  size: Size;
  /** Icon pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  /**
   * Maximum screen share count (value from preset)
   * -1 denotes there is no limit on maximum
   */
  maxScreenShareCount: number;
  screenShareCount: number;
  screenShareEnabled: boolean;
  canScreenShare: boolean;
  shareScreenPermission: MediaPermission;
  private selfScreenShareListener;
  private screenShareListener;
  private participantLeftListener;
  private mediaPermissionErrorListener;
  connectedCallback(): void;
  disconnectedCallback(): void;
  meetingChanged(meeting: Meeting): void;
  private hasPermissionError;
  private reachedMaxScreenShares;
  private toggleScreenShare;
  private getState;
  render(): any;
}
