import { IconPack } from '../../lib/icons';
import { Meeting, Peer } from '../../types/dyte-client';
import { Size, States } from '../../types/props';
import { UIConfig } from '../../types/ui-config';
/**
 * A grid component that renders two lists of participants: `pinnedParticipants` and `participants`.
 *
 * - Participants from `pinnedParticipants[]` are rendered inside a larger grid.
 * - Participants from `participants[]` array are rendered in a smaller grid.
 */
export declare class DyteSpotlightGrid {
  /** Participants */
  participants: Peer[];
  /** Pinned Participants */
  pinnedParticipants: Peer[];
  /**
   * Aspect Ratio of participant tile
   *
   * Format: `width:height`
   */
  aspectRatio: string;
  /** Gap between participant tiles */
  gap: number;
  /** Size */
  size: Size;
  /** Meeting object */
  meeting: Meeting;
  /** States object */
  states: States;
  /** UI Config */
  config: UIConfig;
  /** Icon Pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  host: HTMLDyteSpotlightGridElement;
  render(): any;
}
